import { Context } from 'react';
import { Atom, Scope, WritableAtom } from './atom';
declare const createStoreForProduction: (initialValues?: Iterable<readonly [
    Atom<unknown>,
    unknown
]> | undefined) => readonly [
    {
        _uMS_T: import("./vanilla").State;
        _uMS_V: (target: import("./vanilla").State) => number;
    },
    <Value, Update>(atom: WritableAtom<Value, Update>, update: Update) => void,
    () => void,
    (values: Iterable<readonly [
        Atom<unknown>,
        unknown
    ]>) => void
];
declare const createStoreForDevelopment: (initialValues?: Iterable<readonly [
    Atom<unknown>,
    unknown
]> | undefined) => readonly [
    {
        _uMS_T: import("./vanilla").State;
        _uMS_V: (target: import("./vanilla").State) => number;
    },
    <Value, Update>(atom: WritableAtom<Value, Update>, update: Update) => void,
    () => void,
    (values: Iterable<readonly [
        Atom<unknown>,
        unknown
    ]>) => void,
    {
        _uMS_T: {
            version: number;
            atoms: Atom<unknown>[];
            state: import("./vanilla").State;
            listeners: Set<() => void>;
        };
        _uMS_V: (target: {
            version: number;
            atoms: Atom<unknown>[];
            state: import("./vanilla").State;
            listeners: Set<() => void>;
        }) => number;
    }
];
declare type StoreForProduction = ReturnType<typeof createStoreForProduction>;
export declare type StoreForDevelopment = ReturnType<typeof createStoreForDevelopment>;
export declare type Store = StoreForProduction | StoreForDevelopment;
declare type CreateStore = (initialValues?: Iterable<readonly [
    Atom<unknown>,
    unknown
]>) => Store;
export declare const createStore: CreateStore;
declare type StoreContext = Context<Store>;
export declare const getStoreContext: (scope?: Scope | undefined) => StoreContext;
export declare const isDevStore: (store: Store) => store is readonly [
    {
        _uMS_T: import("./vanilla").State;
        _uMS_V: (target: import("./vanilla").State) => number;
    },
    <Value, Update>(atom: WritableAtom<Value, Update>, update: Update) => void,
    () => void,
    (values: Iterable<readonly [
        Atom<unknown>,
        unknown
    ]>) => void,
    {
        _uMS_T: {
            version: number;
            atoms: Atom<unknown>[];
            state: import("./vanilla").State;
            listeners: Set<() => void>;
        };
        _uMS_V: (target: {
            version: number;
            atoms: Atom<unknown>[];
            state: import("./vanilla").State;
            listeners: Set<() => void>;
        }) => number;
    }
];
export {};
